from threading import Thread
from time import sleep
import asyncio
from EmQuantAPI import *
import traceback
from StockRestData import StockRestData
from BondRestData import BondRestData
from TempIndexRestData import TempIndexRestData
from LimitUpNewsData import LimitUpNewsData

def async_call(fn):
    def wrapper(*args, **kwargs):
        Thread(target=fn, args=args, kwargs=kwargs).start()
    return wrapper

def mainCallback(quantdata):
    print ("mainCallback",str(quantdata))
    #登录掉线或者 登陆数达到上线（即登录被踢下线） 这时所有的服务都会停止
    if str(quantdata.ErrorCode) == "10001011" or str(quantdata.ErrorCode) == "10001009":
        print ("Your account is disconnect. You can force login automatically here if you need.")
    #行情登录验证失败（每次连接行情服务器时需要登录验证）或者行情流量验证失败时，会取消所有订阅，用户需根据具体情况处理
    elif str(quantdata.ErrorCode) == "10001021" or str(quantdata.ErrorCode) == "10001022":
        print ("Your all csq subscribe have stopped.")
    #行情服务器断线自动重连连续6次失败（1分钟左右）不过重连尝试还会继续进行直到成功为止，遇到这种情况需要确认两边的网络状况
    elif str(quantdata.ErrorCode) == "10002009":
        print ("Your all csq subscribe have stopped, reconnect 6 times fail.")
        # 行情订阅遇到一些错误(这些错误会导致重连，错误原因通过日志输出，统一转换成EQERR_QUOTE_RECONNECT在这里通知)，正自动重连并重新订阅,可以做个监控
    elif str(quantdata.ErrorCode) == "10002012":
        print ("csq subscribe break on some error, reconnect and request automatically.")
        # 资讯服务器断线自动重连连续6次失败（1分钟左右）不过重连尝试还会继续进行直到成功为止，遇到这种情况需要确认两边的网络状况
    elif str(quantdata.ErrorCode) == "10002014":
        print ("Your all cnq subscribe have stopped, reconnect 6 times fail.")
    # 资讯订阅遇到一些错误(这些错误会导致重连，错误原因通过日志输出，统一转换成EQERR_INFO_RECONNECT在这里通知)，正自动重连并重新订阅,可以做个监控
    elif str(quantdata.ErrorCode) == "10002013":
        print ("cnq subscribe break on some error, reconnect and request automatically.")
    # 资讯登录验证失败（每次连接资讯服务器时需要登录验证）或者资讯流量验证失败时，会取消所有订阅，用户需根据具体情况处理
    elif str(quantdata.ErrorCode) == "10001024" or str(quantdata.ErrorCode) == "10001025":
        print("Your all cnq subscribe have stopped.")
    else:
        pass

# 获取股票实时数据
async def getStockRest():
    stockRestData = StockRestData()
    print("开始股票")
    stockRestData.toGet()
    
# 获取债券实时数据
async def getBondRest():
    bondRestData = BondRestData()
    print("开始债券")
    bondRestData.toGet()

# 获取指数实时数据
async def getIndexRest():
    tempIndexRestData = TempIndexRestData()
    print("开始指数")
    tempIndexRestData.toGet()

# 获取订阅新闻
async def getLimitUpNewsData():
    limitUpNewsData = LimitUpNewsData()
    print("开始新闻")
    limitUpNewsData.toGet()

# 运行了就不会停了
try:
    #调用登录函数（激活后使用，不需要用户名密码）
    # loginResult = c.start("LoginMode=SXDL,PhoneNumber=15387568630", '', mainCallback)
    loginResult = c.start("ForceLogin=1", '', mainCallback)
    if(loginResult.ErrorCode != 0):
        print("login in fail")
        exit()
    # data = c.csqcancel(0)
    # data = c.csqcancel(-1)
    loop = asyncio.events.get_event_loop()
    tasks= [
        getStockRest(),
        getBondRest(),
        getIndexRest(),
        getLimitUpNewsData()
    ]
    loop.run_until_complete((asyncio.wait(tasks)))
    loop.close()
    while True:
        sleep(1 * 60 * 60)
except Exception as ee:
    print("error >>>",ee)
    #退出
    data = logoutResult = c.stop()
    traceback.print_exc()
else:
    print("demo end")
